// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.Composition;
using ContosoAutomotive.Common;

namespace ContosoAutomotive.Queries
{
    [Export(typeof(ICarQuery))]
    public class BeamTeamQuery : CarQueryBase
    {
        public BeamTeamQuery()
        {
            Name = "Beam Team";
            Description = "Low Mileage, Low Price Beamers that have wonderful resell value.";
            ImagePath = "Images/bmw.jpg";
        }

        protected override IEnumerable<Car> RunQuery(IEnumerable<Car> cars)
        {
            var results = from c in cars
                          where c.Make == "BMW"
                            && (c.Model == "545i" || c.Model == "550i" || c.Model == "645ci")
                            && c.Price <= 40000
                            && c.Year >= 1995
                            && c.Transmission == Transmission.Manual
                            && c.SatelliteRadio == true
                            && c.MoonRoof == true
                            && c.MPG >= 25
                            && c.Mileage <= 60000
                            && c.Interior == InteriorType.Leather
                          select c;

            return results;
        }
    }
}