// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.Composition;
using ContosoAutomotive.Common;

namespace ContosoAutomotive.Queries
{
    [Export(typeof(ICarQuery))]
    public class BentleyBlowout : CarQueryBase
    {
        public BentleyBlowout()
        {
            Name = "Bentley Blowout";
            Description = "Ah, the Bentley. The joy of millionaires. But can we find a low mileage one?";
            ImagePath = "Images/bentley.jpg";
        }

        protected override IEnumerable<Car> RunQuery(IEnumerable<Car> cars)
        {
            var results = from c in cars
                          where c.Make == "Bentley"
                            && c.Price >= 60000
                            && c.Year >= 2000
                            && c.Transmission == Transmission.Automatic
                            && c.SatelliteRadio == true
                            && c.MPG >= 15
                            && c.Mileage <= 60000
                            && c.Interior == InteriorType.Leather
                          select c;

            return results;
        }
    }
}