// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.Composition;
using ContosoAutomotive.Common;

namespace ContosoAutomotive.Queries
{
    [Export(typeof(ICarQuery))]
    public class FordFocusFiestaQuery : CarQueryBase
    {
        public FordFocusFiestaQuery()
        {
            Name = "Ford Focus Fiesta";
            Description = "Grab the Focus. We can make an absolutely steal off these puppies.";
            ImagePath = "Images/ford.jpg";
        }

        protected override IEnumerable<Car> RunQuery(IEnumerable<Car> cars)
        {
            var results = from c in cars
                          where c.Make == "Ford"
                            && c.Model == "Focus"
                            && c.Price <= 20000
                            && c.Year >= 2000
                            && c.Transmission == Transmission.Automatic
                            && c.MPG >= 20
                            && c.Mileage <= 30000
                            && c.Interior == InteriorType.Cloth
                          select c;

            return results;
        }
    }
}