// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.Composition;
using ContosoAutomotive.Common;

namespace ContosoAutomotive.Queries
{
    [Export(typeof(ICarQuery))]
    public class LotusLoveQuery : CarQueryBase
    {
        public LotusLoveQuery()
        {
            Name = "Lotus Love";
            Description = "Plain and simple. I love all Lotus cars and must own them all.";
            ImagePath = "Images/lotus.jpg";
        }

        protected override IEnumerable<Car> RunQuery(IEnumerable<Car> cars)
        {
            var results = from c in cars
                          where c.Make == "Lotus"
                            && c.Model == "Elise"
                            && c.Price <= 40000
                            && c.Year >= 2005
                            && c.Transmission == Transmission.Automatic
                            && c.SatelliteRadio == true
                            && c.MoonRoof == true
                            && c.MPG >= 25
                            && c.Mileage <= 10000
                            && c.Interior == InteriorType.Suede
                          select c;

            return results;
        }
    }
}